
# q-expansion of newform 696.2.a.f, downloaded from the LMFDB on 14 December 2025.

# We generate the q-expansion using the Hecke eigenvalues a_p at the primes.
# Each a_p is given as a linear combination
# of the following basis for the coefficient ring.

def make_data():

    from sage.all import prod, floor, prime_powers, gcd, QQ, primes_first_n, next_prime, RR

    def discrete_log(elts, gens, mod):
        # algorithm 2.2, page 16 of https://arxiv.org/abs/0903.2785
        def table_gens(gens, mod):
            T = [1]
            n = len(gens)
            r = [None]*n
            s = [None]*n
            for i in range(n):
                beta = gens[i]
                r[i] = 1
                N = len(T)
                while beta not in T:
                    for Tj in T[:N]:
                        T.append((beta*Tj) % mod)
                    beta = (beta*gens[i]) % mod
                    r[i] += 1
                s[i] = T.index(beta)
            return T, r, s
        T, r, s = table_gens(gens, mod)
        n = len(gens)
        N = [ prod(r[:j]) for j in range(n) ]
        Z = lambda s: [ (floor(s/N[j]) % r[j]) for j in range(n)]
        return [Z(T.index(elt % mod)) for elt in elts]
    def extend_multiplicatively(an):
        for pp in prime_powers(len(an)-1):
            for k in range(1, (len(an) - 1)//pp + 1):
                if gcd(k, pp) == 1:
                    an[pp*k] = an[pp]*an[k]
    from sage.all import PolynomialRing, NumberField
    R = PolynomialRing(QQ, "x")
    f = R(poly_data)
    K = NumberField(f, "a")
    betas = [K.gens()[0]**i for i in range(len(poly_data))]
    convert_elt_to_field = lambda elt: sum(c*beta for c, beta in zip(elt, betas))
    # convert aps to K elements
    primes = primes_first_n(len(aps_data))
    good_primes = [p for p in primes if not p.divides(level)]
    aps = map(convert_elt_to_field, aps_data)
    if not hecke_ring_character_values:
        # trivial character
        char_values = dict(zip(good_primes, [1]*len(good_primes)))
    else:
        gens = [elt[0] for elt in hecke_ring_character_values]
        gens_values = [convert_elt_to_field(elt[1]) for elt in hecke_ring_character_values]
        char_values = dict([(
            p,prod(g**k for g, k in zip(gens_values, elt)))
            for p, elt in zip(good_primes, discrete_log(good_primes, gens, level))
            ])
    an_list_bound = next_prime(primes[-1])
    an = [0]*an_list_bound
    an[1] = 1
    
    from sage.all import PowerSeriesRing
    PS = PowerSeriesRing(K, "q")
    for p, ap in zip(primes, aps):
        if p.divides(level):
            euler_factor = [1, -ap]
        else:
            euler_factor = [1, -ap, p**(weight - 1) * char_values[p]]
        k = RR(an_list_bound).log(p).floor() + 1
        foo = (1/PS(euler_factor)).padded_list(k)
        for i in range(1, k):
            an[p**i] = foo[i]
    extend_multiplicatively(an)
    return PS(an)
level = 696
weight = 2
poly_data = [0, 1]

# The basis for the coefficient ring is just the power basis
# in the root of the defining polynomial above.
hecke_ring_character_values = None
aps_data = [[0], [1], [-2], [-1], [-3], [-7], [3], [-6], [4], [-1], [0], [-8], [6], [4], [-3], [-10], [10], [0], [9], [-12], [-4], [10], [6], [-3], [-10], [7], [16], [6], [-17], [-9], [-22], [-11], [18], [7], [-16], [4], [22], [-6], [20], [4], [0], [5], [-8], [-10], [2], [1], [6], [-19], [18], [-14], [-14], [-10], [-13], [-15], [24], [-16], [15], [2], [-1], [-14], [-24], [-23], [-28], [-7], [-3], [17], [10], [-30], [-32], [-26], [-14], [4], [8], [6], [-2], [-22], [-3], [2], [-14], [22], [-22], [-2], [-16], [22], [5], [19], [-29], [29], [-18], [-3], [12], [-36], [40], [36], [-17], [17], [22], [0], [-33], [-10], [-5], [-18], [-21], [-31], [8], [4], [42], [34], [-3], [-10], [42], [-47], [-34], [2], [-3], [9], [-23], [8], [41], [43], [-3], [45], [7], [44], [-11], [-44], [-18], [12], [32], [24], [-40], [33], [32], [32], [-38], [-28], [30], [-36], [18], [7], [-15], [42], [-4], [20], [32], [-43], [16], [42], [50], [48], [50], [-3], [-44], [27], [-14], [-11], [-27], [-14], [-45], [-4], [21], [-16], [34], [12], [16], [-52], [-41], [-20]]
